//-----------------------------------------------------------------------
//	File:		$RCSfile: Lab2Top.v,v $
//	Version:	$Revision: 1.1 $
//	Desc:		Lab2 Top Level File
//	Author:		Greg Gibeling
//	Copyright:	Copyright 2003 UC Berkeley
//	This copyright header must appear in all derivative works.
//-----------------------------------------------------------------------

//-----------------------------------------------------------------------
//	Section:	Change Log
//-----------------------------------------------------------------------
//	$Log: Lab2Top.v,v $
//	Revision 1.1  2004/07/07 23:23:34  Administrator
//	Initial Import
//	Fully Tested
//	Solution works
//	
//-----------------------------------------------------------------------

//-----------------------------------------------------------------------
//	Module:		Lab2Top
//	Desc:		...
//-----------------------------------------------------------------------
module Lab2Top(In, Out, Enable, PeakSelect, Clock, Reset);
	//---------------------------------------------------------------
	//	I/O
	//---------------------------------------------------------------
	input	[7:0]		In;
	output	[7:0]		Out;
	//---------------------------------------------------------------

	//---------------------------------------------------------------
	//	Control Signals
	//---------------------------------------------------------------
	input			Enable, PeakSelect;
	//---------------------------------------------------------------

	//---------------------------------------------------------------
	//	System Inputs
	//---------------------------------------------------------------
	input			Clock, Reset;
	//---------------------------------------------------------------

	//---------------------------------------------------------------
	//	Intermediate Wires
	//---------------------------------------------------------------
	wire	[7:0]		Peak, Total;
	//---------------------------------------------------------------

	//---------------------------------------------------------------
	//	Output Multiplexor
	//---------------------------------------------------------------
	assign	Out =		PeakSelect ? Peak : Total;
	//---------------------------------------------------------------

	//---------------------------------------------------------------
	//	Instantiate Submodules
	//---------------------------------------------------------------
	Accumulator	Accumulator(.In(In), .Out(Total), .Enable(Enable), .Clock(Clock), .Reset(Reset));
	PeakDetector	PeakDetector(.In(In), .Out(Peak), .Enable(Enable), .Clock(Clock), .Reset(Reset));
	//---------------------------------------------------------------
endmodule
//-----------------------------------------------------------------------